# Helix Web Services Build Infrastructure

Build infrastructure creates a CD pipeline for creating all artifacts.
The artifacts include the source tarball, installers, documentation, etc, for each build.

Instances can be launched locally for testing.
You will need at least one master and one build instance.

## Tools

* [https://www.vagrantup.com/](Vagrant) is used for local testing
* [http://saltstack.com/](SaltStack) is used for configuration management
* [https://jenkins-ci.org/](Jenkins) is used for continuous delivery

In general, I use VMWare Fusion on OS X, not VirtualBox, and move images into a vSphere environment.


## Build Workflow Overview

1. Changes happen in a branch in the workshop

2. A tarball is generated for the source

3. Package builds are triggered, all consuming the tarball, and each creating 1 package.

	- Run in parallel

4. Documentation is generated, based on the tarball

5. All dependencies and test results are submitted to a branch area in the workshop.
